/*
 * Generated by asn1c-0.9.29 (http://lionet.info/asn1c)
 * From ASN.1 module "ITS-Container"
 * 	found in "ITS-Container.asn"
 * 	`asn1c -fcompound-names -gen-PER`
 */

#include "AltitudeConfidence.h"

int
AltitudeConfidence_constraint(asn_TYPE_descriptor_t *td, const void *sptr,
			asn_app_constraint_failed_f *ctfailcb, void *app_key) {
	/* Replace with underlying type checker */
	td->check_constraints = asn_DEF_NativeEnumerated.check_constraints;
	return td->check_constraints(td, sptr, ctfailcb, app_key);
}

/*
 * This type is implemented using NativeEnumerated,
 * so here we adjust the DEF accordingly.
 */
static void
AltitudeConfidence_1_inherit_TYPE_descriptor(asn_TYPE_descriptor_t *td) {
	td->free_struct    = asn_DEF_NativeEnumerated.free_struct;
	td->print_struct   = asn_DEF_NativeEnumerated.print_struct;
	td->check_constraints = asn_DEF_NativeEnumerated.check_constraints;
	td->ber_decoder    = asn_DEF_NativeEnumerated.ber_decoder;
	td->der_encoder    = asn_DEF_NativeEnumerated.der_encoder;
	td->xer_decoder    = asn_DEF_NativeEnumerated.xer_decoder;
	td->xer_encoder    = asn_DEF_NativeEnumerated.xer_encoder;
	td->uper_decoder   = asn_DEF_NativeEnumerated.uper_decoder;
	td->uper_encoder   = asn_DEF_NativeEnumerated.uper_encoder;
	if(!td->per_constraints)
		td->per_constraints = asn_DEF_NativeEnumerated.per_constraints;
	td->elements       = asn_DEF_NativeEnumerated.elements;
	td->elements_count = asn_DEF_NativeEnumerated.elements_count;
     /* td->specifics      = asn_DEF_NativeEnumerated.specifics;	// Defined explicitly */
}

void
AltitudeConfidence_free(asn_TYPE_descriptor_t *td,
		void *struct_ptr, int contents_only) {
	AltitudeConfidence_1_inherit_TYPE_descriptor(td);
	td->free_struct(td, struct_ptr, contents_only);
}

int
AltitudeConfidence_print(asn_TYPE_descriptor_t *td, const void *struct_ptr,
		int ilevel, asn_app_consume_bytes_f *cb, void *app_key) {
	AltitudeConfidence_1_inherit_TYPE_descriptor(td);
	return td->print_struct(td, struct_ptr, ilevel, cb, app_key);
}

asn_dec_rval_t
AltitudeConfidence_decode_ber(asn_codec_ctx_t *opt_codec_ctx, asn_TYPE_descriptor_t *td,
		void **structure, const void *bufptr, size_t size, int tag_mode) {
	AltitudeConfidence_1_inherit_TYPE_descriptor(td);
	return td->ber_decoder(opt_codec_ctx, td, structure, bufptr, size, tag_mode);
}

asn_enc_rval_t
AltitudeConfidence_encode_der(asn_TYPE_descriptor_t *td,
		void *structure, int tag_mode, ber_tlv_tag_t tag,
		asn_app_consume_bytes_f *cb, void *app_key) {
	AltitudeConfidence_1_inherit_TYPE_descriptor(td);
	return td->der_encoder(td, structure, tag_mode, tag, cb, app_key);
}

asn_dec_rval_t
AltitudeConfidence_decode_xer(asn_codec_ctx_t *opt_codec_ctx, asn_TYPE_descriptor_t *td,
		void **structure, const char *opt_mname, const void *bufptr, size_t size) {
	AltitudeConfidence_1_inherit_TYPE_descriptor(td);
	return td->xer_decoder(opt_codec_ctx, td, structure, opt_mname, bufptr, size);
}

asn_enc_rval_t
AltitudeConfidence_encode_xer(asn_TYPE_descriptor_t *td, void *structure,
		int ilevel, enum xer_encoder_flags_e flags,
		asn_app_consume_bytes_f *cb, void *app_key) {
	AltitudeConfidence_1_inherit_TYPE_descriptor(td);
	return td->xer_encoder(td, structure, ilevel, flags, cb, app_key);
}

asn_dec_rval_t
AltitudeConfidence_decode_uper(asn_codec_ctx_t *opt_codec_ctx, asn_TYPE_descriptor_t *td,
		asn_per_constraints_t *constraints, void **structure, asn_per_data_t *per_data) {
	AltitudeConfidence_1_inherit_TYPE_descriptor(td);
	return td->uper_decoder(opt_codec_ctx, td, constraints, structure, per_data);
}

asn_enc_rval_t
AltitudeConfidence_encode_uper(asn_TYPE_descriptor_t *td,
		asn_per_constraints_t *constraints,
		void *structure, asn_per_outp_t *per_out) {
	AltitudeConfidence_1_inherit_TYPE_descriptor(td);
	return td->uper_encoder(td, constraints, structure, per_out);
}

static asn_per_constraints_t asn_PER_type_AltitudeConfidence_constr_1 GCC_NOTUSED = {
	{ APC_CONSTRAINED,	 4,  4,  0,  15 }	/* (0..15) */,
	{ APC_UNCONSTRAINED,	-1, -1,  0,  0 },
	0, 0	/* No PER value map */
};
static const asn_INTEGER_enum_map_t asn_MAP_AltitudeConfidence_value2enum_1[] = {
	{ 0,	10,	"alt-000-01" },
	{ 1,	10,	"alt-000-02" },
	{ 2,	10,	"alt-000-05" },
	{ 3,	10,	"alt-000-10" },
	{ 4,	10,	"alt-000-20" },
	{ 5,	10,	"alt-000-50" },
	{ 6,	10,	"alt-001-00" },
	{ 7,	10,	"alt-002-00" },
	{ 8,	10,	"alt-005-00" },
	{ 9,	10,	"alt-010-00" },
	{ 10,	10,	"alt-020-00" },
	{ 11,	10,	"alt-050-00" },
	{ 12,	10,	"alt-100-00" },
	{ 13,	10,	"alt-200-00" },
	{ 14,	10,	"outOfRange" },
	{ 15,	11,	"unavailable" }
};
static const unsigned int asn_MAP_AltitudeConfidence_enum2value_1[] = {
	0,	/* alt-000-01(0) */
	1,	/* alt-000-02(1) */
	2,	/* alt-000-05(2) */
	3,	/* alt-000-10(3) */
	4,	/* alt-000-20(4) */
	5,	/* alt-000-50(5) */
	6,	/* alt-001-00(6) */
	7,	/* alt-002-00(7) */
	8,	/* alt-005-00(8) */
	9,	/* alt-010-00(9) */
	10,	/* alt-020-00(10) */
	11,	/* alt-050-00(11) */
	12,	/* alt-100-00(12) */
	13,	/* alt-200-00(13) */
	14,	/* outOfRange(14) */
	15	/* unavailable(15) */
};
static asn_INTEGER_specifics_t asn_SPC_AltitudeConfidence_specs_1 = {
	asn_MAP_AltitudeConfidence_value2enum_1,	/* "tag" => N; sorted by tag */
	asn_MAP_AltitudeConfidence_enum2value_1,	/* N => "tag"; sorted by N */
	16,	/* Number of elements in the maps */
	0,	/* Enumeration is not extensible */
	1,	/* Strict enumeration */
	0,	/* Native long size */
	0
};
static const ber_tlv_tag_t asn_DEF_AltitudeConfidence_tags_1[] = {
	(ASN_TAG_CLASS_UNIVERSAL | (10 << 2))
};
asn_TYPE_descriptor_t asn_DEF_AltitudeConfidence = {
	"AltitudeConfidence",
	"AltitudeConfidence",
	AltitudeConfidence_free,
	AltitudeConfidence_print,
	AltitudeConfidence_constraint,
	AltitudeConfidence_decode_ber,
	AltitudeConfidence_encode_der,
	AltitudeConfidence_decode_xer,
	AltitudeConfidence_encode_xer,
	AltitudeConfidence_decode_uper,
	AltitudeConfidence_encode_uper,
	0,	/* Use generic outmost tag fetcher */
	asn_DEF_AltitudeConfidence_tags_1,
	sizeof(asn_DEF_AltitudeConfidence_tags_1)
		/sizeof(asn_DEF_AltitudeConfidence_tags_1[0]), /* 1 */
	asn_DEF_AltitudeConfidence_tags_1,	/* Same as above */
	sizeof(asn_DEF_AltitudeConfidence_tags_1)
		/sizeof(asn_DEF_AltitudeConfidence_tags_1[0]), /* 1 */
	&asn_PER_type_AltitudeConfidence_constr_1,
	0, 0,	/* Defined elsewhere */
	&asn_SPC_AltitudeConfidence_specs_1	/* Additional specs */
};

